/*
 * AX12.h
 *
 *  Created on: 19 ene. 2021
 *      Author: Josue
 */

#ifndef MODELAX_H_
#define MODELAX_H_

// 0 - Motor Model          2 Byte RD		Range: N/A
// 2 - Firmware Version 	1 Byte RD		Range: N/A
// 3 - Motor ID         	1 Byte RD/WR	Range: 0 - 253
// 4 - Baud Rate 			1 Byte RD/WR	Range: 0 - 254
// 5 - Return Delay Time	1 Byte RD/WR	Range: 0 - 254
// 6 - CW Angle Limit 		2 Byte RD/WR	Range: 0 - 1023
// 8 - CCW Angle Limit		2 Byte RD/WR	Range: 0 - 1023
// 11 - Temperature Limit	1 Byte RD/WR	Range: 0 - 150
// 12 - Minimum Voltage     1 Byte RD/WR	Range: 50 - 250
// 13 - Maximum Voltage 	1 Byte RD/WR	Range: 50 - 250
// 14 - Torque Limit		2 Byte RD/WR	Range: 0 - 1023
// 16 - Status Return Level	1 Byte RD/WR	Range: 0 - 2
// 17 - Alarm LED			1 Byte RD/WR	Range: 0 - 127
// 18 - Alarm Shutdown 		1 Byte RD/WR	Range: 0 - 127
// 19 - Operating Mode		1 Byte RD/WR	Range: 0 - 1
// 20 - Down Calibration	2 Byte RD		Range: Unknown
// 22 - Up Calibration 		2 Byte RD		Range: Unknown
// 24 - Torque Enable 		1 Byte RD/WR	Range: 0 - 1
// 25 - LED					1 Byte RD/WR	Range: 0 - 1
// 26 - CW Compliance M.	1 Byte RD/WR	Range: 0 - 255
// 27 - CCW Compliance M.	1 Byte RD/WR	Range: 0 - 255
// 28 - CW Compliance S. 	1 Byte RD/WR	Range: 0 - 254
// 29 - CCW Compliance S. 	1 Byte RD/WR	Range: 0 - 254
// 30 - Goal Position  		2 Byte RD/WR	Range: 0 - 1023
// 32 - Moving Speed  		2 Byte RD/WR	Range: 0 - 2047
// 34 - Torque Limit   		2 Byte RD/WR	Range: 0 - 1023
// 36 - Present Position 	2 Byte RD		Range: 0 - 1023
// 38 - Present Speed 		2 Byte RD		Range: 0 - 1023
// 40 - Present Load 		2 Byte RD		Range: 0 - 1023
// 42 - Present Voltage		1 Byte RD		Range: 50 - 250
// 43 - Present Temperature	1 Byte RD		Range: 0 - 150
// 44 - Registered Inst.	1 Byte RD/WR	Range: 0 - 1
// 46 - Moving				1 Byte RD		Range: 0 - 1
// 47 - Lock  				1 Byte RD/WR	Range: 0 - 1
// 48 - Punch 				2 Byte RD/WR	Range: 32 - 1023

char AXRegisterDescription[35][30] = {
		"Add: 00, Motor Model          ",		// 2 Byte RD
		"Add: 02, Firmware Version     ",		// 1 Byte RD
		"Add: 03, ID                   ",		// 1 Byte RD/WR
		"Add: 04, Baud Rate            ",		// 1 Byte RD/WR
		"Add: 05, Return Delay Time    ",		// 1 Byte RD/WR
		"Add: 06, CW Angle Limit       ",		// 2 Byte RD/WR
		"Add: 08, CCW Angle Limit      ",		// 2 Byte RD/WR
		"Add: 11, Temperature Limit   ",		// 1 Byte RD/WR
		"Add: 12, Min Voltage Limit   ",		// 1 Byte RD/WR
		"Add: 13, Max Voltage Limit   ",		// 1 Byte RD/WR
		"Add: 14, Max Torque          ",		// 2 Byte RD/WR
		"Add: 16, Status Return Lvl   ",		// 1 Byte RD/WR
		"Add: 17, Alarm LED           ",		// 1 Byte RD/WR
		"Add: 18, Alarm Shutdown      ",		// 1 Byte RD/WR
		"Add: 19, Operating Mode      ",		// 1 Byte RD/WR
		"Add: 20, Down Calibration    ",		// 2 Byte RD
		"Add: 22, Up Calibration      ",		// 2 Byte RD
		"Add: 24, Torque Enable       ",		// 1 Byte RD/WR
		"Add: 25, LED                 ",		// 1 Byte RD/WR
		"Add: 26, CW Compliance M.    ",		// 1 Byte RD/WR
		"Add: 27, CCW Compliance M.   ",		// 1 Byte RD/WR
		"Add: 28, CW Compliance S.    ",		// 1 Byte RD/WR
		"Add: 29, CCW Compliance S.   ",		// 1 Byte RD/WR
		"Add: 30, Goal Position       ",		// 2 Byte RD/WR
		"Add: 32, Moving Speed        ",		// 2 Byte RD
		"Add: 34, Torque Limit        ",		// 2 Byte RD/WR
		"Add: 36, Present Position    ",		// 2 Byte RD
		"Add: 38, Present Speed       ",		// 2 Byte RD
		"Add: 40, Present Load        ",		// 2 Byte RD
		"Add: 42, Present Voltage     ",		// 1 Byte RD
		"Add: 43, Present Temperature ",		// 1 Byte RD
		"Add: 44, Registered Instruc. ",		// 1 Byte RD/WR
		"Add: 46, Moving              ",		// 1 Byte RD
		"Add: 47, Lock                ",		// 1 Byte RD/WR
		"Add: 48, Punch               " 		// 2 Byte RD/WR
};

char AXRegisterRange[35][30] = {
		"Range: N/A              RD   ",		// 0 - Motor Model          2 Byte RD
		"Range: N/A              RD   ",		// 2 - Firmware Version 	1 Byte RD
		"Range: 0 - 253          RD/WR",		// 3 - Motor ID         	1 Byte RD/WR
		"Range: 0 - 254          RD/WR",		// 4 - Baud Rate 			1 Byte RD/WR
		"Range: 0 - 254          RD/WR",		// 5 - Return Delay Time	1 Byte RD/WR
		"Range: 0 - 1023         RD/WR",		// 6 - CW Angle Limit 		2 Byte RD/WR
		"Range: 0 - 1023         RD/WR",		// 8 - CCW Angle Limit		2 Byte RD/WR
		"Range: 0 - 150          RD/WR",		// 11 - Temperature Limit	1 Byte RD/WR
		"Range: 50 - 250         RD/WR",		// 12 - Minimum Voltage     1 Byte RD/WR
		"Range: 50 - 250         RD/WR",		// 13 - Maximum Voltage 	1 Byte RD/WR
		"Range: 0 - 1023         RD/WR",		// 14 - Torque Limit		2 Byte RD/WR
		"Range: 0 - 2            RD/WR",		// 16 - Status Return Level	1 Byte RD/WR
		"Range: 0 - 127          RD/WR",		// 17 - Alarm LED			1 Byte RD/WR
		"Range: 0 - 127          RD/WR",		// 18 - Alarm Shutdown 		1 Byte RD/WR
		"Range: 0 - 1            RD/WR",		// 19 - Operating Mode		1 Byte RD/WR
		"Range: Unknown          RD   ",		// 20 - Down Calibration	2 Byte RD
		"Range: Unknown          RD   ",		// 22 - Up Calibration 		2 Byte RD
		"Range: 0 - 1            RD/WR",		// 24 - Torque Enable 		1 Byte RD/WR
		"Range: 0 - 1            RD/WR",		// 25 - LED					1 Byte RD/WR
		"Range: 0 - 255          RD/WR",		// 26 - CW Compliance M.	1 Byte RD/WR
		"Range: 0 - 255          RD/WR",		// 27 - CCW Compliance M.	1 Byte RD/WR
		"Range: 0 - 254          RD/WR",		// 28 - CW Compliance S. 	1 Byte RD/WR
		"Range: 0 - 254          RD/WR",		// 29 - CCW Compliance S. 	1 Byte RD/WR
		"Range: 0 - 1023         RD/WR",		// 30 - Goal Position  		2 Byte RD/WR
		"Range: 0 - 1023         RD/WR",		// 32 - Moving Speed  		2 Byte RD
		"Range: 0 - 1023         RD/WR",		// 34 - Torque Limit   		2 Byte RD/WR
		"Range: 0 - 1023         RD   ",		// 36 - Present Position 	2 Byte RD
		"Range: 0 - 1023         RD   ",		// 38 - Present Speed 		2 Byte RD
		"Range: 0 - 1023         RD   ",		// 40 - Present Load 		2 Byte RD
		"Range: 50 - 250         RD   ",		// 42 - Present Voltage		1 Byte RD
		"Range: 0 - 150          RD   ",		// 43 - Present Temperature	1 Byte RD
		"Range: 0 - 1            RD/WR",		// 44 - Registered Inst.	1 Byte RD/WR
		"Range: 0 - 1            RD   ",		// 46 - Moving				1 Byte RD
		"Range: 0 - 1            RD/WR",		// 47 - Lock  				1 Byte RD/WR
		"Range: 32 - 1023        RD/WR" 		// 48 - Punch 				2 Byte RD/WR
};

char AXRegisterBytes[35] = {
		2, // Address 0 Motor Model
		1, // Address 2 Motor Firmware Version
		1, // Address 3 Motor ID
		1, // Address 4 UART Baud Rate
		1, // Address 5 Return Delay Time
		2, // Address 6 CW Angle Limit
		2, // Address 8 CCW Angle Limit
		1, // Address 11 Temperature Limit
		1, // Address 12 Min Voltage Limit
		1, // Address 13 Max Voltage Limit
		2, // Address 14 Max Torque
		1, // Address 16 Status Return Level
		1, // Address 17 Alarm LED
		1, // Address 18 Alarm Shutdown
		1, // Address 19 Operating Mode
		2, // Address 20 Down Calibration
		2, // Address 22 Up Calibration
		1, // Address 24 Torque Enable
		1, // Address 25 LED
		1, // Address 26 CW Compliance Margin
		1, // Address 27 CCW Compliance Margin
		1, // Address 28 CW Compliance Slope
		1, // Address 29 CCW Compliance Slope
		2, // Address 30 Goal Position
		2, // Address 32 Moving Speed
		2, // Address 34 Torque Limit
		2, // Address 36 Present Position
		2, // Address 38 Present Speed
		2, // Address 40 Present Load
		1, // Address 42 Present Voltage
		1, // Address 43 Present Temperature
		1, // Address 44 Registered Instruction
		1, // Address 46 Moving
		1, // Address 47 Lock
		2, // Address 48 Punch
};

char AXRegisterAddress[35] = {
		0,2,3,4,5,6,8,11,12,13,14,16,17,18,19,20,22,24,25,26,27,28,29,30,32,34,36,38,40,42,43,44,46,47,48
};

char AXRegisterLock[35] = {
		1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,0,0
};


#endif /* MODELAX_H_ */
